<script setup lang="ts">
    import { SilabError } from '@/shared/errors/SilabError'
    import { isIphone, queryCameraPermission } from '@/shared/helpers/device'
    import { isDefined, isUndefined } from '@/shared/helpers/types'
    import { ref, onMounted, onUnmounted, watchEffect } from 'vue'

    const emit = defineEmits<{
        capturePhoto: [ImageBitmap]
        close: [void]
    }>()

    const photoCaptureContainer = ref<HTMLDivElement | undefined>(undefined)
    const video = ref<HTMLVideoElement | undefined>()
    const videoDevices = ref<MediaDeviceInfo[]>([])
    const stream = ref<MediaStream | undefined>(undefined)
    const currentVideoDeviceIndex = ref<number>(0)
    const flashRef = ref<HTMLDivElement | undefined>(undefined)
    const numberOfPhoto = ref<number>(0)

    async function getVideoDevices() {
        try {
            await queryCameraPermission()
            const allDevices = await navigator.mediaDevices.enumerateDevices()
            videoDevices.value = allDevices
                .filter((device) => device.kind === 'videoinput')
                .reverse() //Le but du reverse est d'avoir la camera arrière ouverte en premier sur les appareils mobiles
        } catch (error) {
            throw new SilabError(
                `Erreur lors de la récupération des périphériques vidéo`,
                error
            )
        }
    }

    async function updateStreamFromCamera(deviceId: string) {
        if (isUndefined(video.value)) {
            return
        }
        if (isDefined(stream.value)) {
            const tracks = stream.value.getTracks()
            tracks.forEach((track) => track.stop())
        }
        try {
            stream.value = await navigator.mediaDevices.getUserMedia({
                video: {
                    deviceId,
                    width: window.innerWidth,
                },
            })
        } catch (error) {
            throw new SilabError(`Erreur d'accès à la caméra`, error)
        }
    }

    watchEffect(() => {
        if (isUndefined(video.value)) {
            return
        }
        video.value.srcObject = stream.value ?? null
    })

    getVideoDevices().then(() => {
        updateStreamFromCamera(
            videoDevices.value[currentVideoDeviceIndex.value].deviceId
        )
    })

    function switchCamera() {
        currentVideoDeviceIndex.value =
            (currentVideoDeviceIndex.value + 1) % videoDevices.value.length

        updateStreamFromCamera(
            videoDevices.value[currentVideoDeviceIndex.value].deviceId
        )
    }

    async function capturePhoto() {
        if (isUndefined(video.value)) {
            return
        }

        emit('capturePhoto', await createImageBitmap(video.value))
        showFlashingEffect()
        numberOfPhoto.value++
    }

    function showFlashingEffect() {
        if (flashRef.value) {
            flashRef.value.style.opacity = '1'
            setTimeout(() => {
                if (flashRef.value) {
                    flashRef.value.style.opacity = '0'
                }
            }, 200)
        }
    }

    onMounted(() => {
        if (!isIphone()) {
            photoCaptureContainer.value?.requestFullscreen()
        }
    })

    onUnmounted(() => {
        if (isDefined(stream.value)) {
            const tracks = stream.value.getTracks()
            tracks.forEach((track) => track.stop())
        }
    })
</script>

<template>
    <div
        ref="photoCaptureContainer"
        class="position-fixed top-0 right-0 w-100 h-100 bg-black"
        style="z-index: 2000"
    >
        <video
            ref="video"
            autoplay
            muted
            playsinline
            style="width: 100%; height: 100%"
        ></video>
        <v-btn
            prepend-icon="mdi-arrow-left"
            color="background"
            class="position-absolute top-0 left-0 ma-4"
            @click="() => emit('close')"
            >{{
                numberOfPhoto > 0
                    ? `+ ${numberOfPhoto} photo${numberOfPhoto > 1 ? 's' : ''}`
                    : 'Retour'
            }}</v-btn
        >
        <v-btn
            v-if="videoDevices.length > 1"
            icon="mdi-camera-switch"
            color="background"
            class="position-absolute top-0 right-0 ma-4"
            @click="switchCamera"
        ></v-btn>
        <div class="position-absolute bottom-0 left-0 right-0 text-center">
            <v-btn icon="mdi-camera" class="mb-4" @click="capturePhoto"></v-btn>
        </div>
        <div
            ref="flashRef"
            style="
                position: absolute;
                top: 0;
                left: 0;
                width: 100%;
                height: 100%;
                background: white;
                opacity: 0;
                pointer-events: none;
                z-index: 10;
                transition: opacity 0.2s ease;
            "
        ></div>
    </div>
</template>
